; System variables.

ERR_NR	.equ $4000		; 16384
FLAGS	.equ $4001		; 16385
ERR_SP	.equ $4002		; 16386
RAMTOP	.equ $4004		; 16388
MODE	.equ $4006		; 16390
PPC	.equ $4007		; 16391

; ===========================================================
; Start of the Program
; ===========================================================

; Origin of a ZX81 file is always 16393

	.org $4009
                
VERSN	.db 0
E_PPC	.dw 2
D_FILE	.dw Display
DF_CC	.dw Display+1                  ; First character of display
VARS	.dw Variables
DEST	.dw 0
E_LINE	.dw BasicEnd 
CH_ADD	.dw BasicEnd+4                 ; Simulate SAVE "X"
X_PTR	.dw 0
STKBOT	.dw BasicEnd+5
STKEND	.dw BasicEnd+5                 ; Empty stack
BREG	.db 0
MEM	.dw MEMBOT
UNUSED1	.db 0
DF_SZ	.db 2
S_TOP	.dw $0002                      ; Top program line number
LAST_K	.dw $FDBF
DEBOUN	.db 15
MARGIN	.db 55
NXTLIN	.dw Line1                      ; Next line address
OLDPPC	.dw 0
FLAGX	.db 0
STRLEN	.dw 0
T_ADDR	.dw $0C8D
SEED	.dw 0
FRAMES	.dw $F5A3
COORDS	.dw 0
PR_CC	.db $BC
S_POSN	.dw $1821
CDFLAG	.db $40
PRBUFF	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,$76 ; 32 Spaces + Newline
MEMBOT	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 30 zeros
UNUSED2	.dw 0

; End of system variables

Program        
Line0
	.db $00,$00                    ; Line 0
	.dw Line0End-Line0Text         ; Line 0 length
Line0Text
	.db $EA                        ; REM             
   
; ===========================================================
; Eller's maze generator
; ===========================================================

nextmaze
	ld hl,LAST_K		;
	ld a,(hl)		;
chk_keys
	cp (hl)			;
	jr z,chk_keys		;

;	=========================

	exx			;

	ld hl,Display+66	;
	ld c,29			;
	exx			;

	ld hl,PRBUFF+15		;
	ld bc,$0F10		;
fillloop
	dec hl			;
	ld (hl),b		;
	djnz fillloop		;

	ld b,10			;
nextrow1
	ld hl,PRBUFF		;

;	-------------------------
nextcol1
	scf			; room
	call cmdPrint		;
	jr z,nextrow2		;
	
	ld a,(hl)		;
	inc hl			;
	cp (hl)			;
	jr nz,connect1		;

	and a
	jr loopend1		;
connect1
	call setRND		; set CY, if connect
	call c,setUnion		; 
loopend1
	call cmdPrint		;
	jr nextcol1		;

;	-------------------------
nextrow2
	ld hl,PRBUFF		;

;	-------------------------
nextcol2
	push bc			;
	push hl			;
	ld a,(hl)		;

	ld hl,PRBUFF		;
	ld bc,$0F00		;
count
	cp (hl)			;
	jr nz,nocount		;
	inc c			;
nocount
	inc hl			;
	djnz count		;
	dec c			;

	pop hl			;
	pop bc			;
countend
	scf			; connect
	jr z,connect2		;

	call setRND		;
	jr c,connect2		;
	
	ld (hl),c		;
	inc c			;
connect2
	call cmdPrint		;
	jr z,loopend2

	and a			;
	call cmdPrint		; wall
	inc hl
	jr nextcol2		;

loopend2
	djnz nextrow1		;

;	-------------------------

	ld hl,PRBUFF
nextcol3
	scf			; room
	call cmdPrint		;
	
	jr z,start		;

	ld a,(hl)		;
	inc hl			;
	cp (hl)			;
	jr z,loopend3		;

	call setUnion		;
	scf
loopend3
	call cmdPrint		;
	jr nextcol3

;	=========================
cmdPrint
	exx			;
	ld (hl),$80		;
	jr nc,nextpos		;

	ld (hl),$00		;
nextpos
	inc hl			;
	dec c			;
	jr nz,endPrint		;

	inc hl			;
	inc hl			;
	inc hl			;
	ld c,29			;
endPrint
	exx			;
	ret			;

;	=========================
setRND
	push hl			;
	ld hl,(SEED)		;
	ld a,r			;
	ld d,a			;
	ld e,(hl)		;
	add hl,de		;
	add a,l			;
	xor h			;
	ld (SEED),hl		;
	pop hl			;

	cp $80			;
	ret			;

;	=========================
setUnion
	push af			;
	push bc			;
	push hl			;

	ld b,32			;
	ld a,(hl)		;
	dec hl			;
	ld c,(hl)		;

	ld hl,PRBUFF		;
unioloop
	cp (hl)			;
	jr nz,unionext		;
	ld (hl),c		;
unionext
	inc hl
	djnz unioloop		;

	pop hl			;
	pop bc			;
	pop af			;
	ret

; ===========================================================
; start race
; ===========================================================
start
	ld hl,Variables-34	;
	ld (hl),0		;
	ld hl,Display+65	;
new_pos
	ld (hl),8		;
wt_loop
	exx			;
wt_0sec1
	ld b,5
	ld hl,FRAMES		;
wt_newfr
	ld a,(hl)		;
wt_frame
	cp (hl)			
	jr z,wt_frame		;

	djnz wt_newfr		;
key_test
	ld bc,(LAST_K)		;
	inc c			;
	jr z,wt_0sec1		;

	dec c			;
	call $07BD		; DECODE
	ld a,(hl)		;

	exx
	ld d,h			;
	ld e,l			;

	ld bc,$20		;

	sub 38			; "A"
	jr z,add_BC		;

	sub 16			; "Q"
	jr z,sub_BC		;

	ld c,$01		;
	add a,c			; "P"
	jr z,add_BC		;

	xor $FF			; "O"
	jr nz,chk_new		;
sub_BC
	sbc hl,bc		;
	jr test_pos		;
add_BC
	add hl,bc		;
test_pos
	ld a,(hl)		;
	cp 0			;
	jr z,new_pos		;

	ex de,hl		;
	cp 8			;
	jr nz,wt_loop		;

	ld (hl),0		;
	ex de,hl		;
	jr wt_loop		;
chk_new
	dec a			;
	jp z,nextmaze		;
	jr wt_loop		;

; ===========================================================
; End of user program
; ===========================================================

	.db $76                        ; Newline
Line0End       
Line1	.db $00,$01                    ; Line 1
	.dw Line1End-Line1Text         ; Line 1 length
Line1Text
	.db $F9,$D4                    ; RAND USR
	.db $1D,$22,$21,$1D,$20        ; 16514
	.db $7E                        ; Number
	.db $8F,$01,$04,$00,$00        ; Numeric encoding
	.db $76                        ; Newline
Line1End 

; Display file.
Display
	.db $76	; Newline
	.db $2A,$31,$31,$2A,$37,$17,$38,$00,$32,$26,$3F,$2A,$00,$2C,$2A,$33
	.db $2A,$37,$26,$39,$34,$37,$00,$1E,$1C,$1D,$22,$17,$2C,$3F,$38,$76 ; Line 01 
	.db $80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80
	.db $80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$76 ; Line 02
	.db $08,$08,$08,$08,$80,$00,$80,$00,$00,$00,$80,$B4,$80,$96,$80,$80
	.db $B1,$AA,$AB,$B9,$80,$00,$00,$00,$80,$00,$00,$00,$00,$00,$80,$76 ; Line 03
	.db $80,$80,$80,$08,$80,$00,$80,$00,$80,$00,$80,$B5,$80,$96,$80,$B7
	.db $AE,$AC,$AD,$B9,$80,$00,$80,$80,$80,$80,$80,$80,$80,$00,$80,$76 ; Line 04
	.db $80,$00,$00,$08,$08,$08,$08,$08,$80,$00,$80,$B6,$80,$96,$80,$80
	.db $80,$80,$BA,$B5,$80,$00,$80,$00,$80,$08,$08,$08,$80,$00,$80,$76 ; Line 05
	.db $80,$80,$80,$80,$80,$80,$80,$08,$80,$80,$80,$A6,$80,$96,$80,$80
	.db $A9,$B4,$BC,$B3,$80,$00,$80,$00,$80,$08,$80,$08,$80,$00,$80,$76 ; Line 06
	.db $80,$00,$80,$00,$80,$00,$80,$08,$00,$00,$80,$B3,$80,$96,$80,$80
	.db $80,$B3,$AA,$BC,$80,$00,$80,$08,$08,$08,$80,$08,$08,$08,$80,$76 ; Line 07
	.db $80,$00,$80,$00,$80,$00,$80,$08,$80,$80,$80,$80,$80,$80,$80,$80
	.db $80,$80,$80,$80,$80,$00,$80,$08,$80,$80,$80,$80,$80,$08,$80,$76 ; Line 08
	.db $80,$00,$80,$00,$80,$08,$08,$08,$80,$00,$80,$00,$00,$00,$00,$00
	.db $80,$00,$80,$00,$80,$00,$80,$08,$80,$00,$00,$08,$08,$08,$80,$76 ; Line 09
	.db $80,$00,$80,$00,$80,$08,$80,$80,$80,$00,$80,$00,$80,$80,$80,$80
	.db $80,$00,$80,$00,$80,$00,$80,$08,$80,$00,$80,$08,$80,$00,$80,$76 ; Line 10
	.db $80,$00,$80,$00,$80,$08,$00,$00,$80,$00,$80,$00,$00,$00,$80,$00
	.db $80,$00,$80,$08,$08,$08,$80,$08,$80,$00,$80,$08,$80,$00,$80,$76 ; Line 11
	.db $80,$00,$80,$00,$80,$08,$80,$80,$80,$00,$80,$80,$80,$00,$80,$00
	.db $80,$00,$80,$08,$80,$08,$80,$08,$80,$80,$80,$08,$80,$80,$80,$76 ; Line 12
	.db $80,$00,$80,$00,$00,$08,$80,$00,$80,$00,$80,$00,$80,$00,$80,$00
	.db $00,$08,$08,$08,$80,$08,$08,$08,$80,$00,$00,$08,$00,$00,$80,$76 ; Line 13
	.db $80,$00,$80,$80,$80,$08,$80,$00,$80,$00,$80,$00,$80,$00,$80,$80
	.db $80,$08,$80,$80,$80,$80,$80,$00,$80,$00,$80,$08,$80,$80,$80,$76 ; Line 14
	.db $80,$00,$00,$00,$00,$08,$80,$00,$80,$00,$80,$00,$00,$00,$00,$00
	.db $00,$08,$80,$00,$00,$00,$80,$00,$80,$00,$80,$08,$08,$08,$80,$76 ; Line 15
	.db $80,$00,$80,$00,$80,$08,$80,$00,$80,$00,$80,$80,$80,$80,$80,$80
	.db $80,$08,$80,$00,$80,$80,$80,$00,$80,$80,$80,$80,$80,$08,$80,$76 ; Line 16
	.db $80,$00,$80,$00,$80,$08,$08,$08,$80,$00,$80,$00,$00,$08,$08,$08
	.db $08,$08,$80,$00,$00,$00,$00,$00,$80,$00,$80,$00,$00,$08,$80,$76 ; Line 17
	.db $80,$00,$80,$00,$80,$00,$80,$08,$80,$00,$80,$00,$80,$08,$80,$80
	.db $80,$00,$80,$00,$80,$80,$80,$80,$80,$00,$80,$80,$80,$08,$80,$76 ; Line 18
	.db $80,$00,$80,$00,$80,$00,$80,$08,$80,$00,$80,$00,$80,$08,$00,$00
	.db $80,$00,$80,$00,$80,$00,$80,$00,$00,$00,$00,$00,$80,$08,$80,$76 ; Line 19
	.db $80,$80,$80,$80,$80,$80,$80,$08,$80,$00,$80,$80,$80,$08,$80,$00
	.db $80,$80,$80,$80,$80,$00,$80,$80,$80,$00,$80,$00,$80,$08,$80,$76 ; Line 20
	.db $80,$00,$80,$00,$80,$00,$00,$08,$80,$00,$80,$00,$00,$08,$80,$00
	.db $80,$00,$80,$00,$00,$00,$00,$80,$00,$00,$80,$08,$08,$08,$80,$76 ; Line 21
	.db $80,$00,$80,$00,$80,$00,$80,$08,$80,$00,$80,$80,$80,$08,$80,$00
	.db $80,$00,$80,$00,$80,$80,$80,$80,$80,$80,$80,$08,$80,$80,$80,$76 ; Line 22
	.db $80,$00,$00,$00,$00,$00,$80,$08,$08,$08,$08,$08,$08,$08,$80,$00
	.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$80,$08,$08,$08,$08,$76 ; Line 23
	.db $80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80
	.db $80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$76 ; Line 24               

; Variables area (empty)
Variables:      
VariablesEnd:	.db $80
BasicEnd:                              
