; System variables.

ERR_NR	.equ $4000		; 16384
FLAGS	.equ $4001		; 16385
ERR_SP	.equ $4002		; 16386
RAMTOP	.equ $4004		; 16388
MODE	.equ $4006		; 16390
PPC	.equ $4007		; 16391

; ===========================================================
; Start of the Program
; ===========================================================

; Origin of a ZX81 file is always 16393

	.org $4009
                
VERSN	.db 0
E_PPC	.dw 2
D_FILE	.dw Display1
DF_CC	.dw Display1+1                  ; First character of display
VARS	.dw Variables
DEST	.dw 0
E_LINE	.dw BasicEnd 
CH_ADD	.dw BasicEnd+4                 ; Simulate SAVE "X"
X_PTR	.dw 0
STKBOT	.dw BasicEnd+5
STKEND	.dw BasicEnd+5                 ; Empty stack
BREG	.db 0
MEM	.dw MEMBOT
UNUSED1	.db 0
DF_SZ	.db 2
S_TOP	.dw $0002                      ; Top program line number
LAST_K	.dw $FDBF
DEBOUN	.db 15
MARGIN	.db 55
NXTLIN	.dw Line1                      ; Next line address
OLDPPC	.dw 0
FLAGX	.db 0
STRLEN	.dw 0
T_ADDR	.dw $0C8D
SEED	.dw 0
FRAMES	.dw $F5A3
COORDS	.dw 0
PR_CC	.db $BC
S_POSN	.dw $1821
CDFLAG	.db $40
PRBUFF	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,$76 ; 32 Spaces + Newline
MEMBOT	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 30 zeros
UNUSED2	.dw 0

; End of system variables

Program        
Line0
	.db $00,$00                    ; Line 0
	.dw Line0End-Line0Text         ; Line 0 length
Line0Text
	.db $EA                        ; REM             
   
; ===========================================================
; Eller's maze generator
; ===========================================================

	exx			;

	ex de,hl		;
	dec hl			;
	dec hl			;
	dec hl			;
	ld (hl),$83		;

	ld hl,LAST_K		;
	ld a,(hl)		;
chk_keys
	cp (hl)			;
	jr z,chk_keys		;


;	=========================
nextmaze

	ld hl,Display1+68	;
	ld d,h			;
	ld e,l			;
	ld b,h			;
	ld c,l			;
	exx			;

	ld hl,PRBUFF+31		;
	ld bc,$1F20		;
fillloop
	dec hl			;
	ld (hl),b		;
	djnz fillloop		;

	ld b,21			;
nextrow1
	ld hl,PRBUFF		;

;	-------------------------
nextcol1
	call PlotRoom		; room
	jr z,nextrow2		;
	
	ld a,(hl)		;
	inc hl			;
	cp (hl)			;
	jr nz,connect1		;

	and a
	jr loopend1		;
connect1
	call setRND		; set CY, if connect
	call c,setUnion		; 
loopend1
	call HConnect		;
	jr nextcol1		;

;	-------------------------
nextrow2
	ld hl,PRBUFF		;

;	-------------------------
nextcol2
	push bc			;
	push hl			;
	ld a,(hl)		;

	ld hl,PRBUFF		;
	ld bc,$1F00		;
count
	cp (hl)			;
	jr nz,nocount		;
	inc c			;
nocount
	inc hl			;
	djnz count		;
	dec c			;

	pop hl			;
	pop bc			;
countend
	scf			; connect
	jr z,connect2		;

	call setRND		;
	jr c,connect2		;
	
	ld (hl),c		;
	inc c			;
connect2
	call VConnect		;
	jr z,loopend2

	inc hl
	jr nextcol2		;

loopend2
	djnz nextrow1		;

;	-------------------------

	ld hl,PRBUFF
nextcol3
	call PlotRoom		; room
	
	jp z,start		;

	ld a,(hl)		;
	inc hl			;
	cp (hl)			;
	jr z,loopend3		;

	call setUnion		;
	scf
loopend3
	call HConnect		;
	jr nextcol3

;	=========================
PlotRoom
	exx			;

	ld a,$81		; plot a 
	ld (bc),a		; room
	inc bc			; set pointer
	ld a,(bc)		; then check
	cp $76			; end of line
	jr nz,PlotREnd		; if it is

	inc bc			; then
	inc bc			; set the
PlotPEnd
	ld h,b			; pointers to
	ld l,c			; next line
	ex de,hl		; hl now points the 1st pos. of the prev. line
PlotREnd
	exx			;
	ret

;	=========================
HConnect
	ld a,2			;
	jr PlotPath		;
VConnect
	ld a,4			;
PlotPath
	exx			;
	jr nc,nextpos		;

	add a,(hl)		;
	ld (hl),a		;
nextpos
	inc hl			;
	ld a,(hl)		;
	cp $76			;
	jr z,PlotPEnd		;

	exx			;
	ret

;	=========================
setRND
	push hl			;
	ld hl,(SEED)		;
	ld a,r			;
	ld d,a			;
	ld e,(hl)		;
	add hl,de		;
	add a,l			;
	xor h			;
	ld (SEED),hl		;
	pop hl			;

	cp $80			;
	ret

;	=========================
setUnion
	push af			;
	push bc			;
	push hl			;

	ld b,31			;
	ld a,(hl)		;
	dec hl			;
	ld c,(hl)		;

	ld hl,PRBUFF		;
unioloop
	cp (hl)			;
	jr nz,unionext		;
	ld (hl),c		;
unionext
	inc hl
	djnz unioloop		;

	pop hl			;
	pop bc			;
	pop af			;
	ret

;	=========================
set_offs
	rr h			; Y/2
	rla			; 0000000y
	rr l			; X/2
	rla			; 000000yx
	cp $01			; x=y=0?
	rla			; 00000yxz

	ld b,$00		;
	ld c,l			; BC=X/2
	ld l,h			;
	ld e,h			;
	ld h,b			; HL=Y/2
	ld d,b			; DE=Y/2
	add hl,hl		; *2
	add hl,hl		; *4
	add hl,hl		; *8
	add hl,hl		; *16
	add hl,hl		; *32
	add hl,de		; *33
	add hl,bc		; (Y/2)*33+(X/2)
	ex de,hl		; DE=offset

	ld c,a			; C=mask

	ld hl,Display1+68	;
	add hl,de		; displ. addr.
	ld a,(hl)		;

	ret

; ===========================================================
; start race
; ===========================================================
start
	exx			;
	ex de,hl		;
	dec hl			;
	dec hl			;
	dec hl			;
	ld (hl),$83		;

	ld hl,Display1+67	;
	ld e,2			;
	ld bc,$00FF		;
wt_loop	
	ld a,(hl)		;
	xor e			; toggle cursor
	ld (hl),a		;
	exx

	ld b,5
	ld hl,FRAMES		;
wt_newfr
	ld a,(hl)		;
wt_frame
	cp (hl)			
	jr z,wt_frame		;

	djnz wt_newfr		;

	ld bc,(LAST_K)		;
	inc c			;

	exx			;
	jr z,wt_loop		;

	ld a,(hl)		;
	or e			; hide cursor
	ld (hl),a		;
	ld a,e			;
	ld (old_mask),a		;
	exx
wt_exit
	dec c			;
	call $07BD		; ROM: DECODE
	ld a,(hl)		;

	exx			;
	ld d,b			;
	ld e,c			;
test_key
	sub 38			; "A"
	jr nz,test_Q		;
	
	inc b 			;
	jr test_pos
test_Q
	sub 16			; "Q"
	jr nz,test_P		;

	dec b 			;
	jr test_pos
test_P
	inc a			; "P"
	jr nz,test_O		;

	inc c 			;
	jr test_pos
test_O
	inc a			; "O"
	jr nz,test_N		;

	dec c
test_pos
	ld a,c			;
	cp 62			; (0..61)
	jr nc,invalid1		;
	
	ld a,b			;
	cp 43			; (0..42)
	jr nc,invalid1		;

	and c			;
	and 1			;
	jr nz,invalid1		; wall

	push bc			;
	exx			;
	pop hl			;
	call set_offs		;

	and c			;
	jr z,invalid		; wall

	ld a,c			; the mask
	push hl			;

	exx			;
	pop hl			; HL=new addr.
	ld e,a			; save the mask

	jr wt_loop		;
invalid
	exx			;
invalid1
	ld b,d			;
	ld c,e			;

old_mask .equ $+1

	ld e,1			;
	jr wt_loop		;
test_N
	inc a			;
	jr nz,wt_loop		;

	exx
	jp nextmaze		;

; ===========================================================
; End of user program
; ===========================================================

	.db $76                        ; Newline
Line0End       
Line1	.db $00,$01                    ; Line 1
	.dw Line1End-Line1Text         ; Line 1 length
Line1Text
	.db $F9,$D4                    ; RAND USR
	.db $1D,$22,$21,$1D,$20        ; 16514
	.db $7E                        ; Number
	.db $8F,$01,$04,$00,$00        ; Numeric encoding
	.db $76                        ; Newline
Line1End 

; Display file.
Display1
	.db $76
	.db $85,$AA,$B1,$B1,$AA,$B7,$97,$B8,$80,$B2,$A6,$BF,$AA,$80,$AC,$AA
	.db $B3,$AA,$B7,$A6,$B9,$B4,$B7,$80,$9E,$9C,$9D,$A2,$97,$AC,$BF,$B8,$76	; line 1
	.db $87,$83,$83,$83,$83,$83,$83,$83,$83,$83,$83,$83,$83,$83,$83,$83
	.db $83,$83,$83,$83,$83,$83,$83,$83,$83,$83,$83,$83,$83,$83,$83,$83,$76	; line 2
	.db $87,$87,$81,$85,$85,$85,$85,$85,$83,$85,$85,$B4,$80,$96,$80,$80
	.db $B1,$AA,$AB,$B9,$82,$87,$83,$83,$83,$85,$85,$87,$81,$85,$87,$81,$76	; line 3
	.db $85,$87,$85,$87,$85,$83,$85,$85,$83,$87,$85,$B5,$80,$96,$80,$B7
	.db $AE,$AC,$AD,$B9,$82,$85,$83,$87,$87,$81,$83,$85,$85,$87,$85,$85,$76	; line 4
	.db $85,$81,$83,$81,$87,$81,$85,$85,$87,$85,$81,$B6,$80,$96,$80,$80
	.db $80,$80,$BA,$B5,$82,$81,$87,$81,$83,$81,$83,$85,$87,$81,$87,$81,$76	; line 5
	.db $85,$85,$87,$81,$85,$85,$87,$83,$81,$83,$85,$A6,$80,$96,$80,$80
	.db $A9,$B4,$BC,$B3,$82,$81,$83,$87,$85,$85,$83,$85,$85,$85,$87,$85,$76	; line 6
	.db $85,$85,$85,$87,$81,$83,$85,$85,$83,$83,$85,$B3,$80,$96,$80,$80
	.db $80,$B3,$AA,$BC,$82,$83,$85,$85,$83,$87,$83,$87,$87,$85,$85,$85,$76	; line 7
	.db $85,$83,$87,$83,$81,$87,$83,$83,$81,$87,$85,$84,$84,$84,$84,$84
	.db $84,$84,$84,$84,$86,$81,$85,$87,$81,$85,$85,$85,$85,$81,$85,$81,$76	; line 8
	.db $85,$87,$85,$83,$87,$85,$85,$83,$85,$81,$87,$87,$87,$81,$81,$85
	.db $85,$87,$87,$81,$85,$85,$87,$81,$85,$81,$85,$81,$87,$81,$85,$85,$76	; line 9
	.db $85,$85,$85,$85,$81,$87,$83,$83,$85,$85,$81,$81,$87,$81,$85,$87
	.db $81,$81,$83,$83,$87,$81,$83,$81,$85,$83,$87,$83,$87,$81,$83,$81,$76	; line 10
	.db $85,$81,$85,$87,$85,$81,$87,$81,$85,$83,$87,$81,$81,$85,$85,$87
	.db $81,$85,$85,$87,$87,$83,$87,$85,$85,$83,$83,$85,$83,$81,$83,$85,$76	; line 11
	.db $85,$85,$87,$81,$83,$81,$87,$81,$87,$81,$83,$83,$85,$85,$85,$85
	.db $85,$83,$85,$81,$85,$85,$81,$83,$83,$87,$81,$83,$87,$81,$85,$85,$76	; line 12
	.db $85,$83,$83,$85,$83,$85,$85,$87,$83,$87,$83,$81,$83,$85,$85,$83
	.db $85,$85,$85,$85,$83,$85,$85,$85,$87,$85,$87,$81,$81,$87,$87,$81,$76	; line 13
	.db $85,$85,$87,$83,$85,$87,$85,$83,$81,$83,$87,$87,$81,$85,$87,$87
	.db $83,$81,$85,$87,$83,$85,$87,$87,$81,$81,$85,$87,$81,$85,$81,$85,$76	; line 14
	.db $85,$85,$85,$85,$85,$85,$85,$83,$87,$87,$81,$83,$83,$85,$85,$81
	.db $83,$85,$83,$85,$85,$81,$81,$85,$83,$85,$87,$81,$85,$87,$81,$85,$76	; line 15
	.db $85,$83,$85,$85,$87,$85,$87,$87,$81,$81,$83,$87,$87,$81,$81,$83
	.db $83,$85,$83,$83,$85,$83,$87,$83,$83,$87,$81,$87,$81,$85,$87,$81,$76	; line 16
	.db $85,$85,$87,$81,$85,$81,$81,$85,$83,$83,$85,$81,$85,$87,$83,$81
	.db $85,$87,$87,$87,$85,$87,$81,$85,$83,$87,$85,$83,$85,$83,$87,$81,$76	; line 17
	.db $85,$85,$83,$81,$85,$85,$87,$85,$85,$83,$85,$85,$87,$87,$81,$85
	.db $85,$85,$85,$81,$81,$87,$85,$85,$83,$81,$87,$85,$87,$87,$85,$85,$76	; line 18
	.db $85,$83,$85,$85,$81,$85,$81,$83,$83,$85,$85,$85,$81,$87,$81,$83
	.db $87,$85,$85,$85,$85,$85,$83,$81,$85,$85,$85,$83,$81,$81,$87,$85,$76	; line 19
	.db $85,$85,$83,$85,$85,$85,$85,$83,$83,$81,$85,$85,$87,$81,$85,$83
	.db $81,$85,$83,$87,$85,$83,$85,$85,$87,$83,$87,$83,$87,$85,$81,$81,$76	; line 20
	.db $85,$85,$85,$87,$83,$85,$85,$85,$85,$85,$87,$83,$81,$85,$87,$87
	.db $81,$83,$85,$81,$83,$81,$85,$85,$83,$81,$87,$85,$81,$85,$85,$85,$76	; line 21
	.db $85,$87,$81,$85,$87,$83,$83,$83,$85,$85,$87,$83,$85,$87,$85,$85
	.db $83,$85,$87,$85,$83,$85,$87,$85,$85,$87,$81,$83,$85,$83,$87,$81,$76	; line 22
	.db $85,$87,$81,$81,$87,$83,$87,$85,$87,$81,$87,$85,$83,$81,$81,$83
	.db $87,$81,$81,$85,$85,$87,$85,$83,$81,$83,$81,$87,$81,$85,$81,$85,$76	; line 23
	.db $85,$83,$83,$83,$83,$81,$81,$81,$83,$83,$81,$83,$83,$83,$83,$81
	.db $83,$83,$81,$83,$81,$81,$83,$83,$83,$83,$81,$83,$83,$83,$83,$83,$76	; line 24

; Variables area (empty)
Variables
	.db $80		; VariablesEnd
BasicEnd                          
	.end
